/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// UnsignedTx struct for UnsignedTx
type UnsignedTx struct {
	// The transaction ID.
	Id *string `json:"id,omitempty"`
	// The transaction data needed to sign.
	UnsignedTx string          `json:"unsigned_tx"`
	Meta       *UnsignedTxMeta `json:"meta,omitempty"`
}

// NewUnsignedTx instantiates a new UnsignedTx object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUnsignedTx(unsignedTx string) *UnsignedTx {
	this := UnsignedTx{}
	this.UnsignedTx = unsignedTx
	return &this
}

// NewUnsignedTxWithDefaults instantiates a new UnsignedTx object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUnsignedTxWithDefaults() *UnsignedTx {
	this := UnsignedTx{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *UnsignedTx) GetId() string {
	if o == nil || o.Id == nil {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UnsignedTx) GetIdOk() (*string, bool) {
	if o == nil || o.Id == nil {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *UnsignedTx) HasId() bool {
	if o != nil && o.Id != nil {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *UnsignedTx) SetId(v string) {
	o.Id = &v
}

// GetUnsignedTx returns the UnsignedTx field value
func (o *UnsignedTx) GetUnsignedTx() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UnsignedTx
}

// GetUnsignedTxOk returns a tuple with the UnsignedTx field value
// and a boolean to check if the value has been set.
func (o *UnsignedTx) GetUnsignedTxOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UnsignedTx, true
}

// SetUnsignedTx sets field value
func (o *UnsignedTx) SetUnsignedTx(v string) {
	o.UnsignedTx = v
}

// GetMeta returns the Meta field value if set, zero value otherwise.
func (o *UnsignedTx) GetMeta() UnsignedTxMeta {
	if o == nil || o.Meta == nil {
		var ret UnsignedTxMeta
		return ret
	}
	return *o.Meta
}

// GetMetaOk returns a tuple with the Meta field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UnsignedTx) GetMetaOk() (*UnsignedTxMeta, bool) {
	if o == nil || o.Meta == nil {
		return nil, false
	}
	return o.Meta, true
}

// HasMeta returns a boolean if a field has been set.
func (o *UnsignedTx) HasMeta() bool {
	if o != nil && o.Meta != nil {
		return true
	}

	return false
}

// SetMeta gets a reference to the given UnsignedTxMeta and assigns it to the Meta field.
func (o *UnsignedTx) SetMeta(v UnsignedTxMeta) {
	o.Meta = &v
}

func (o UnsignedTx) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Id != nil {
		toSerialize["id"] = o.Id
	}
	if true {
		toSerialize["unsigned_tx"] = o.UnsignedTx
	}
	if o.Meta != nil {
		toSerialize["meta"] = o.Meta
	}
	return json.Marshal(toSerialize)
}

type NullableUnsignedTx struct {
	value *UnsignedTx
	isSet bool
}

func (v NullableUnsignedTx) Get() *UnsignedTx {
	return v.value
}

func (v *NullableUnsignedTx) Set(val *UnsignedTx) {
	v.value = val
	v.isSet = true
}

func (v NullableUnsignedTx) IsSet() bool {
	return v.isSet
}

func (v *NullableUnsignedTx) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUnsignedTx(val *UnsignedTx) *NullableUnsignedTx {
	return &NullableUnsignedTx{value: val, isSet: true}
}

func (v NullableUnsignedTx) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUnsignedTx) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
